# SoTransformManip Class Reference
[Manipulators]

`#include <Inventor/manips/SoTransformManip.h>`

Inheritance diagram for SoTransformManip:

List of all members.

## Detailed Description

The SoTransformManip class is used to manipulate transformations.

A manipulator is used by replacing the node you want to edit in the graph with the manipulator. Draggers are used to to manipulate the node. When manipulation is finished, the node is put back into the graph, replacing the manipulator.

The SoTransformManip class is an abstract class which should not be used directly -- use one of it's subclasses.

## Public Member Functions

| SoTransformManip (void)
SoDragger * | getDragger (void)
SbBool | replaceNode (SoPath *p)
SbBool | replaceManip (SoPath *p, SoTransform *newone) const
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | search (SoSearchAction *action)
virtual SoChildList * | getChildren (void) const

## Static Public Member Functions

void | initClass (void)

## Protected Member Functions

| ~SoTransformManip ()
void | setDragger (SoDragger *newdragger)
virtual void | copyContents (const SoFieldContainer *fromfc, SbBool copyconnections)
void | attachSensors (const SbBool onoff)

## Static Protected Member Functions

void | transferFieldValues (const SoTransform *from, SoTransform *to)
void | valueChangedCB (void *f, SoDragger *d)
void | fieldSensorCB (void *f, SoSensor *d)

## Protected Attributes

SoFieldSensor * | rotateFieldSensor
SoFieldSensor * | translFieldSensor
SoFieldSensor * | scaleFieldSensor
SoFieldSensor * | centerFieldSensor
SoFieldSensor * | scaleOrientFieldSensor
SoChildList * | children

## Constructor & Destructor Documentation

SoTransformManip::SoTransformManip | ( | void |  | ) |

| The constructor.

SoTransformManip::~SoTransformManip | ( |  | ) | `[protected]`

| The destructor.

## Member Function Documentation

void SoTransformManip::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoTransform. Reimplemented in SoCenterballManip, SoHandleBoxManip, SoJackManip, SoTabBoxManip, SoTrackballManip, SoTransformBoxManip, and SoTransformerManip.

SoDragger * SoTransformManip::getDragger | ( | void |  | ) |

| Returns the dragger used by this manipulator.

SbBool SoTransformManip::replaceNode | ( | SoPath * | path | ) |

Replaces a node at the tail end of path with this manipulator. The node must be an instance of a node class derived from SoTransform.

The manipulator will when inserted automatically copy the field data from the node, to make it initially affect the state in the same way as the node.

Returns `TRUE` if successful, and `FALSE` if the given node could not be replaced with the manipulator. The operation will for instance fail if the tail node of the given path is not of SoTransform type, or for any other condition where it is not possible to replace the node with this manipulator.

SbBool SoTransformManip::replaceManip | ( | SoPath * | path,
|  | SoTransform * | newone
| ) | const

| Replaces this manipulator from the position specified by path with newnode. If newnode is `NULL`, an SoTransform will be created for you.

void SoTransformManip::doAction | ( | SoAction * | action | ) | `[virtual]`

| This function performs the typical operation of a node for any action. Reimplemented from SoTransform.

void SoTransformManip::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoTransform.

void SoTransformManip::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoTransform.

void SoTransformManip::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) | `[virtual]`

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculates their bounding box also overrides this method to change the relevant state variables.

Reimplemented from SoTransform.

void SoTransformManip::getMatrix | ( | SoGetMatrixAction * | action | ) | `[virtual]`

| Action method for SoGetMatrixAction. Updates action by accumulating with the transformation matrix of this node (if any). Reimplemented from SoTransform.

void SoTransformManip::handleEvent | ( | SoHandleEventAction * | action | ) | `[virtual]`

| Action method for SoHandleEventAction. Inspects the event data from action, and processes it if it is something which this node should react to. Nodes influencing relevant state variables for how event handling is done also overrides this method. Reimplemented from SoNode.

void SoTransformManip::pick | ( | SoPickAction * | action | ) | `[virtual]`

| Action method for SoPickAction. Does common processing for SoPickAction action instances. Reimplemented from SoTransform.

void SoTransformManip::search | ( | SoSearchAction * | action | ) | `[virtual]`

Action method for SoSearchAction.

Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction -- if any of the requested criteria is a miss, the search is not deemed successful for the node.

See also:
  SoSearchAction

Reimplemented from SoNode.

SoChildList * SoTransformManip::getChildren | ( | void |  | ) | const`[virtual]`

| Returns the children of this node. This node only has the dragger as a child. Reimplemented from SoNode.

void SoTransformManip::setDragger | ( | SoDragger * | newdragger | ) | `[protected]`

| Sets up the dragger instance to be controlled by this manipulator. Reimplemented in SoCenterballManip.

void SoTransformManip::copyContents | ( | const SoFieldContainer * | fromfc,
|  | SbBool | copyconnections
| ) | `[protected, virtual]`

Makes a deep copy of all data of from into this instance, except external scenegraph references if copyconnections is `FALSE`.

This is the protected method that should be overridden by extension node / engine / dragger / whatever subclasses which needs to account for internal data that are not handled automatically.

Note that for simply copying e.g. a node from application code, it should be sufficient to do:

      SoNode * mynewnode = templatenode->copy();

Make sure that when you override the copyContents() method in your extension class that you also make it call upwards to it's parent superclass in the inheritance hierarchy, as copyContents() in for instance SoNode and SoFieldContainer does important work. It should go something like this:

      void
      MyCoinExtensionNode::copyContents(const SoFieldContainer * from,
                                        SbBool copyconnections)
      {
        // let parent superclasses do their thing (copy fields, copy
        // instance name, etc etc)
        SoNode::copyContents(from, copyconnections);

        // [..then copy internal data..]
      }

Reimplemented from SoNode.

void SoTransformManip::transferFieldValues | ( | const SoTransform * | from,
|  | SoTransform * | to
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Copies field values from one node to the other.

void SoTransformManip::valueChangedCB | ( | void * | m,
|  | SoDragger * | dragger
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Callback to update field values when motion matrix changes. Reimplemented in SoCenterballManip.

void SoTransformManip::fieldSensorCB | ( | void * | m,
|  | SoSensor * | d
| ) | `[static, protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer. Callback to update motion matrix when a field is modified. Reimplemented in SoCenterballManip.

void SoTransformManip::attachSensors | ( | const SbBool | onoff | ) | `[protected]`

| Can be used by subclasses to attach/detach field sensors.

## Member Data Documentation

SoFieldSensor * SoTransformManip::rotateFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoFieldSensor * SoTransformManip::translFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoFieldSensor * SoTransformManip::scaleFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoFieldSensor * SoTransformManip::centerFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoFieldSensor * SoTransformManip::scaleOrientFieldSensor`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

SoChildList * SoTransformManip::children`[protected]`

| This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

The documentation for this class was generated from the following files:

- SoTransformManip.h
- SoTransformManip.cpp
- commoncode.cpp